#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <utility>
#include <string>
#include <deque>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <vector>
using namespace std;

#define debug printf
//#define debug blackhole
void blackhole(...) {}

#define MAXN 20000
int ADJ_N[MAXN];
int V;
int E;

void GO() {
	for (int i=0;i<MAXN;i++) {
		ADJ_N[i]=0;
	}
	for (int i = 0; i < E; i++) {
		int a, b;
		scanf("%d%d", &a, &b);
		ADJ_N[a]++;
		ADJ_N[b]++;
	}

	int qq;
	for (qq=0;qq<V;qq++) {
		if (ADJ_N[qq] >= 4){
			printf("YES\n");
			break;
		}
	}
	if (qq==V) printf("NO\n");
}

int main() {
	while (true) {
		if (scanf("%d%d", &V, &E) != 2) break;
		GO();
	}
	return 0;
}
